/* Example sketch 10 SOFT POTENTIOMETER */

const int RED_LED_PIN = 9;    // Red LED Pin
const int GREEN_LED_PIN = 10; // Green LED Pin
const int BLUE_LED_PIN = 11;  // Blue LED Pin

const int SENSOR_PIN = 0;      // Analog input pin

// Global PWM brightness values for the RGB LED.
// These are global so both loop() and setRGB() can see them.

int redValue, greenValue, blueValue;


void setup()
{
  // No need for any code here
  // analogWrite() sets up the pins as outputs
}


void loop()
{
  int sensorValue;

  // Read the voltage from the softpot (0-1023)
  
  sensorValue = analogRead(0);

  // We've written a new function called setRGB() (further down
  // in the sketch) that decodes sensorValue into a position
  // on the RGB "rainbow", and sets the RGB LED to that color.
 
  setRGB(sensorValue);
}


// setRGB()
// Set a RGB LED to a position on the "rainbow" of all colors.
// RGBposition should be in the range of 0 to 1023 (such as
// from an analog input).

void setRGB(int RGBposition)
{
  int mapRGB;  
   //녹색은 341에서 최대가 되고 주변으로 갈수록 어두워 진다.
  mapRGB = map(abs(RGBposition-341), 0, 341, 255, 0);
  greenValue = constrain(mapRGB, 0, 255);
  //청색은 682에서 최대가 되고 주변으로 갈수록 어두워 진다.
  mapRGB = map(abs(RGBposition-682), 0, 341, 255, 0);
  blueValue = constrain(mapRGB, 0, 255);

  //적색은 0에서 최대가 되고 그 중간으로 갈수록 어두워 진다.
  mapRGB = map(RGBposition, 0, 341, 255, 0);
  redValue = constrain(mapRGB, 0, 255);
  
  //적색은 1023에서도 최대가 되고 그 중간으로 갈수록 어두워 진다.
  mapRGB = map(1023-RGBposition, 0, 341, 255, 0);
  redValue = redValue + constrain(mapRGB, 0, 255);
              


  analogWrite(RED_LED_PIN, redValue);
  analogWrite(GREEN_LED_PIN, greenValue);
  analogWrite(BLUE_LED_PIN, blueValue);
  
}
